#ifndef MAIN_H
#define MAIN_H

#include <fstream>
#include <iostream>
#include <stdlib.h>
#include <vector>
#include <deque>
#include <list>
#include <time.h>
#include <cmath>
#include <stdio.h>
#include <iomanip>
#include <string>
#include <algorithm>

using namespace std;

//Holds all the details of the graph being considered
struct GRAPH
{
	int n;
	int m;
	int k;
	vector<vector<bool> > adj;
	vector<vector<int> > adjList;
	vector<int> deg;
	vector<int> precol;
	vector<int> precolList;
	int minDeg;
	int maxDeg;
};

//Holds all the details of a complete solution
struct SOL
{
	vector<vector<int> > items;
	vector<int> numPreass;
	vector<int> col;
	vector<bool> isHappy;
	int numHappy;
};

void exitAndLog(string msg);

#include "algfns.h"
#include "initsol.h"
#include "IO.h"
#include "bounds.h"

#endif //MAIN_H

